

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   AutoNumber Proton Plugin 1.2                                  *
    *   Copyright  2004 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under LGPL.                      *
    *   See LGPL.txt for details.                        2004-09-30   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



// CALL ORDER

// 01 dllmain
// 02   version
// 03   plugin
// 04   type
// 05 dllmain



#include <windows.h>

#include "devil_compile.h"
#include "engine.h"


#define REPLACE_SELECTION	1
#define REPLACE_ALL			2


int iReturn = 0;



/******************************************************************************************************
**  execute                                                                                      @1  **
******************************************************************************************************/

char * __stdcall execute( char * szOriginal, int iSelStart, int iSelLen )
{
	char * out = NULL;
	if( iSelLen > 0 )
	{
		// Process selection
		char * in = new char[ iSelLen + 1 ];
		memcpy( in, szOriginal + iSelStart, iSelLen );
		in[ iSelLen ] = '\0';

		engine( in, out, 2 );
		iReturn = REPLACE_SELECTION;

		delete [] in;
	}
	else
	{
		// Process whole file
		UINT in_len = strlen( szOriginal );
		if( in_len == 0 )
		{
			return NULL;
		}

		engine( szOriginal, out, 2 );
		iReturn = REPLACE_ALL;
	}


	// Finishing newline?
	UINT out_len = strlen( out );
	bool bNewlineFinish =	( out_len >= 2 ) &&
							( out[ out_len - 2 ] == '\x0D' ) &&
							( out[ out_len - 1 ] == '\x0A' );


	// Save last newline by doubling
	if( bNewlineFinish )
	{
		out[ out_len     ] = '\x0D';
		out[ out_len + 1 ] = '\x0A';
		out[ out_len + 2 ] = '\0';
	}


	return out;
}
 

/******************************************************************************************************
**  get_return_type                                                                              @2  **
******************************************************************************************************/

int __stdcall get_return_type()
{
    return iReturn;
}


/******************************************************************************************************
**  get_interface_version                                                                        @3  **
******************************************************************************************************/

int __stdcall get_interface_version()
{
    return 1;
}
